{: Contains a demonstration work class that calculates prime numbers.}
unit PrimeWork;

interface

uses SysUtils, Classes, WorkUnit ;

type
  {: Demonstration work class that calculates a list of prime numbers between two values.}
  TPrimeWork = class( TWork )
  private
    FFromValue: integer ;
    FToValue: integer ;
    FResults: TStrings;
  protected
    procedure Perform ; override ;
  public
    constructor Create( const AIdentification : string ;
                        const AFromValue, AToValue : integer ) ;
    destructor Destroy ; override ;
    property  Results : TStrings read FResults ;
    property  FromValue : integer read FFromValue ;
    property  ToValue : integer read FToValue ;
  end ;

implementation

uses PrimeUnit ;

{ TPrimeWork }

{: Notes the from and to values over which to check for primes and
   creates a string list to hold the results.}
constructor TPrimeWork.Create(const AIdentification : string ;
  const AFromValue, AToValue: integer);
begin
  inherited Create( AIdentification ) ;
  FFromValue := AFromValue ;
  FToValue := AToValue ;
  FResults := TStringList.Create ;
end;

{: Frees the string list used to hold results.}
destructor TPrimeWork.Destroy;
begin
  FResults.Free ;
  inherited;
end;

{: Performs work by searching for primes in the range passed to <see method=Create>.
   When a number is found to be prime, a string is added to the list and the number
   itself is added to the Objects property by typecasting to TObject.}
procedure TPrimeWork.Perform;
var i : integer ;
begin
  for i := FFromValue to FToValue do
    if IsPrime( i ) then
      FResults.AddObject( Format( '%d is prime', [ i ] ), TObject( i ) ) ;
end;

end.
